# hack workaround for Qt/PyQt nvidia bug on linux (see http://goo.gl/pGPgVz)
import ctypes; ctypes.CDLL('libGL.so.1', ctypes.RTLD_GLOBAL)
import os, sys

import PyQt5.QtQuick as QtQuick
import PyQt5.QtWidgets as QtWidgets
import PyQt5.QtCore as QtCore
import PyQt5.QtGui as QtGui
import PyQt5.QtQml as QtQml

class MyScene(QtQuick.QQuickPaintedItem):
    def __init__(self, parent = None):
        super(MyScene, self).__init__(parent)
        
        # PROBLEM LINE IS BELOW.  Uncomment to segfault at start.  Comment to segfault at exit.
        #self._graphics_scene = QtWidgets.QGraphicsScene(self)
        # PROBLEM LINE IS ABOVE

    def paint(self, painter):
        rect = QtCore.QRectF(0, 0, self.width(), self.height())
        painter.drawPie(rect, 0 * 16, 90 * 16)

if __name__ == '__main__':
    app = QtGui.QGuiApplication(sys.argv)
    QtQml.qmlRegisterType(MyScene, "MyScenes", 1, 0, "MyScene")
    
    view = QtQuick.QQuickView()
    view.setResizeMode(QtQuick.QQuickView.SizeRootObjectToView)
    
    qmlPath = os.path.join(os.path.dirname(__file__), "segfault.qml")
    view.setSource(QtCore.QUrl.fromLocalFile(qmlPath))
    view.show()
    
    sys.exit(app.exec_())
